Description

AttachmentController raise RecordNotFound if attachment filename does not match with http request parameter "filename"

  def find_attachment

                                                                                                  

                                                                    

    @attachment = Attachment.find(params[:id])

                                                                                                  

                                           

    

# Show 404 if the filename in the url is wrong                                                    

                                                                                     

    raise ActiveRecord::RecordNotFound if params[:filename] && params[:filename] != @attachment.

filename                                                                                   

    @project = @attachment.project

                                                                                                  

                                                       

  rescue ActiveRecord::RecordNotFound

                                                                                                  

                                                    

    render_404

                                                                                                  

                                                                           

  end    

 if http parameter contain semicolon, webserver puma - drop it and characters after.

According to rfc1738 (https://tools.ietf.org/html/rfc1738#section-3.3) such behavior is correct, because semicolon is reserved symbol,

and must be encoded in %3B (in url)

Puma issue (https://github.com/puma/puma/issues/1122) - here is little bit more information about trouble.

I try use attachment_path helper in app/views/attachments/_links.html.erb (instead hash in link_to), and it seems to be improve

situation, url was encoded right, with %3B instead ";"

History

#1 - 2017-10-16 15:55 - Toshi MARUYAMA

- Description updated

- Category set to Attachments

#2 - 2017-10-23 09:55 - Vladimir Kh

A temporary solution for me:

./config/initializers/semicolon-fix.rb

class ActionDispatch::Journey::Router::Utils::UriEncoder

  PUMASEGMENT  = /[^#{UNRESERVED}#{SUB_DELIMS.gsub(';','')}:@]/.freeze

  def escape_segment(segment)
    escape(segment, PUMASEGMENT)

  end

end

#3 - 2020-03-21 12:14 - Toshi MARUYAMA

- File puma.png added

- Status changed from New to Closed

Fixed by https://github.com/puma/puma/pull/1934
puma.png 20.1 KB 2020-03-21 Toshi MARUYAMA
